/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dailyschedule.dialog.classes;
import java.util.Date;

import com.sos.dailyschedule.DashBoardConstants;
import com.sos.dialog.interfaces.ITableView;
import com.sos.jobnet.dialog.classes.SosJobNetTable;
 
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Listener;

public class SOSDashboardTableViewJobNet extends SOSDashboardTableView implements ITableView {
	private static final String	conSettingREFRESHDefault	= "60";
	private static final String	SOS_DASHBOARD_HEADER_JOBNET	= "sosDashboardHeaderJobnet";
	private static final String	conSettingREFRESH			= "refresh";
	private static final int	NUMBER_OF_COLUMNS_IN_GRID	= 9;
	// final String conSOSDashB_show_log_in_new_tab = "SOSDashB_show_log_in_new_tab"; // "Show log in a new tab";
	// final String conSOSDashB_Today = "SOSDashB_Today"; // "Today";
	// final String conSOSDashB_Reset = "SOSDashB_Reset"; // "Reset";
	private static final String	conTabLOG					= "Log";

	public SOSDashboardTableViewJobNet(Composite composite_) {
		super(composite_);
	}

	@Override
	public void createTable() {
	   
        tableList = new SosJobNetTable(mainViewComposite, SWT.FULL_SELECTION);
        getList();
        
        
		sosDashboardHeader.getRefreshButton().addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				getList();
				getSchedulerIds();
			}
		});
		sosDashboardHeader.getCbSchedulerId().addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				tableDataProvider.setSchedulerId(sosDashboardHeader.getCbSchedulerId().getText());
				getList();
			}
		});
		sosDashboardHeader.getToDate().addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				tableDataProvider.setTo(sosDashboardHeader.getTo());
				getList();
			}
		});
		sosDashboardHeader.getFromDate().addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				tableDataProvider.setFrom(sosDashboardHeader.getFrom());
				getList();
			}
		});
		sosDashboardHeader.getRefreshInterval().setText(prefs.node(SOS_DASHBOARD_HEADER_JOBNET).get(conSettingREFRESH, conSettingREFRESHDefault));
		sosDashboardHeader.getRefreshInterval().addModifyListener(new ModifyListener() {
			public void modifyText(final ModifyEvent arg0) {
				sosDashboardHeader.setRefresh(getIntValue(sosDashboardHeader.getRefreshInterval().getText(), 10));
				sosDashboardHeader.resetRefreshTimer();
				prefs.node(SOS_DASHBOARD_HEADER_JOBNET).put(conSettingREFRESH, sosDashboardHeader.getRefreshInterval().getText());
			}
		});
		sosDashboardHeader.getSearchField().addModifyListener(new ModifyListener() {
			public void modifyText(final ModifyEvent e) {
				if (sosDashboardHeader.getSearchField() != null) {
					tableDataProvider.setSearchField(sosDashboardHeader.getSearchField().getText());
					sosDashboardHeader.resetInputTimer();
				}
			}
		});
		 
		this.setColumnsListener();
	}

	@Override
	public void createMenue() {
		Menu contentMenu = new Menu(tableList);
		tableList.setMenu(contentMenu);
		MenuItem showLog = new MenuItem(contentMenu, SWT.PUSH);
		showLog.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_show_log_in_new_tab));
		showLog.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				SosTabLogItem tbtmLog = new SosTabLogItem(conTabLOG, logTabFolder);
				logTabFolder.setSelection(tbtmLog);
				showLog(tableList);
			}

			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		// =============================================================================================
		MenuItem today = new MenuItem(contentMenu, SWT.PUSH);
		today.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_Today));
		today.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				tableDataProvider.setFrom(new Date());
				tableDataProvider.setTo(new Date());
				getList();
			}

			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		// =============================================================================================
		MenuItem reset = new MenuItem(contentMenu, SWT.PUSH);
		reset.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_Reset));
		reset.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				tableDataProvider.resetFilter();
				tableDataProvider.setFrom(new Date());
				tableDataProvider.setTo(new Date());
				sosDashboardHeader.reset();
				getList();
			}

			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
	}
}
