/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.db;

/**
* \class JobnetEdgesDBItem 
* 
* \brief JobnetEdgesDBItem - 
* 
* \details
*
* \section JobnetEdgesDBItem.java_intro_sec Introduction
*
* \section JobnetEdgesDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 23.09.2011
* \see reference
*
* Created on 23.09.2011 15:08:05
 */

 
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.sos.hibernate.classes.DbItem;
import com.sos.jobnet.interfaces.IEdgesItem;
import com.sos.jobnet.interfaces.INodesItem;
 

@Entity
@Table(name="SCHEDULER_JOB_NET_EDGES")
		
public class JobNetEdgesDBItem extends DbItem implements IEdgesItem {
	
	@SuppressWarnings("unused")
     private final String	conClassName	= "JobNetEdgesDBItem";
	 public  final String	conSVNVersion	= "$Id: JobNetEdgesDBItem.java 16620 2012-02-28 11:08:57Z ur $";

	 private Long edgeId; 
	 private JobNetNodeDBItem jobnetNodeDBItem; 
	 private Long parentNodeId;
	 private Long nodeId;
	 private String edgeType;
  	 
  
	public JobNetEdgesDBItem() {
 	   super();
 	}
	
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="EDGE_ID")
    public Long getEdgeId() {
		return edgeId;
	}

    @Column(name="EDGE_ID")
	public void setEdgeId(Long edgeId) {
		this.edgeId = edgeId;
	}
 	
    @ManyToOne(optional=false)
    @JoinColumn (name="PARENT_NODE_ID", referencedColumnName="NODE_ID")
    public JobNetNodeDBItem getJobnetNodeDBItem() {
    	return jobnetNodeDBItem;
    }
    public void setJobnetNodeDBItem(JobNetNodeDBItem jobnetNodeDBItem) {
    	this.jobnetNodeDBItem = jobnetNodeDBItem;
    }
    
  
    @Column(name="PARENT_NODE_ID",nullable=true, updatable = false, insertable = false)
	public void setParentNodeId(Long parentNodeId) {
		this.parentNodeId = parentNodeId;
	}
 
    @Column(name="PARENT_NODE_ID",nullable=true, updatable = false, insertable = false)
	public Long getParentNodeId() {
		return parentNodeId;
	} 
    
    
    @Column(name="CHILD_NODE_ID",nullable=true)
	public void setChildNodeId(Long nodeId) {
		this.nodeId = nodeId;
	}
 
    @Column(name="CHILD_NODE_ID",nullable=true)
	public Long getChildNodeId() {
		return nodeId;
	}
    
    @Column(name="EDGE_TYPE",nullable=false)
	public void setEdgeType(String edgeType) {
		this.edgeType = edgeType;
	}
 
    @Column(name="EDGE_TYPE",nullable=false)
	public String getEdgeType() {
		return this.edgeType;
	}

	@Transient
    @Override
	public INodesItem getJobnetNodeItem() {
		return getJobnetNodeDBItem();
	}
    
 
 
	
	
}
