/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: async_io.cxx 13322 2008-01-27 15:27:19Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#include "zschimmer.h"
#include "async_io.h"
#include "log.h"

namespace zschimmer {
namespace io {

using namespace ::std;



Async_output_stream::~Async_output_stream()
{
}

Filter_async_output_stream::~Filter_async_output_stream()
{
}

int Filter_async_output_stream::try_write_bytes( const Byte_sequence& )
{
    return 0;   // ??
}

bool Filter_async_output_stream::try_flush()
{
    return false;   // ??
}

//--------------------------------------------------------Buffered_async_output_stream::write_bytes

void Buffered_async_output_stream::write_bytes( const Byte_sequence& s )
{
    try_flush();

    if( _string_list.is_empty() )
    {
        size_t written = _async_output_stream->try_write_bytes( s );

        if( written < s.length() )
        {
            _string_list.append( string( (const char*)s.ptr() + written, s.length() - written ) );
        }
    }
}

//----------------------------------------------------------Buffered_async_output_stream::try_flush

bool Buffered_async_output_stream::try_flush()
{
    while( !_string_list.is_empty() )
    {
        Byte_sequence byte_sequence = _string_list.next_byte_sequence();
        size_t written = _async_output_stream->try_write_bytes( byte_sequence );
        size_t length  = byte_sequence.length();
        _string_list.eat( written );

        if( written < length )  break;
    }

    return _string_list.is_empty();
}

//-------------------------------------------------------------------------------------------------

} //namespace io
} //namespace zschimmer
